diff --git a/plugins/xrandr/Makefile.am b/plugins/xrandr/Makefile.am
index 78637e6..f647b1a 100644
--- a/plugins/xrandr/Makefile.am
+++ b/plugins/xrandr/Makefile.am
@@ -1,16 +1,26 @@
 icondir = $(datadir)/icons/hicolor
 context = apps
+stock_config_icon_dir = $(datadir)/gnome-settings-daemon/xrandr
 
 BUILT_SOURCES =				\
 	gsd-xrandr-manager-glue.h
 
-ICON_FILES = 			\
-	gsd-xrandr-16.png	\
-	gsd-xrandr-22.png	\
-	gsd-xrandr-24.png	\
-	gsd-xrandr-32.png	\
+ICON_FILES =				\
+	gsd-xrandr-16.png		\
+	gsd-xrandr-22.png		\
+	gsd-xrandr-24.png		\
+	gsd-xrandr-32.png		\
 	gsd-xrandr.svg
 
+STOCK_CONFIG_ICON_FILES =		\
+	gsd-xrandr-clone-laptop.png	\
+	gsd-xrandr-clone-monitors.png	\
+	gsd-xrandr-custom.png		\
+	gsd-xrandr-extended-ontop.png	\
+	gsd-xrandr-extended-right.png	\
+	gsd-xrandr-external.png		\
+	gsd-xrandr-laptop.png
+
 install-data-local:
 	$(mkinstalldirs) $(DESTDIR)$(icondir)/16x16/$(context)
 	$(mkinstalldirs) $(DESTDIR)$(icondir)/22x22/$(context)
@@ -22,6 +32,14 @@ install-data-local:
 	$(INSTALL_DATA) $(srcdir)/gsd-xrandr-24.png $(DESTDIR)$(icondir)/24x24/$(context)/gsd-xrandr.png
 	$(INSTALL_DATA) $(srcdir)/gsd-xrandr-32.png $(DESTDIR)$(icondir)/32x32/$(context)/gsd-xrandr.png
 	$(INSTALL_DATA) $(srcdir)/gsd-xrandr.svg $(DESTDIR)$(icondir)/scalable/$(context)/gsd-xrandr.svg
+	$(MKDIR_P) $(stock_config_icon_dir)
+	$(INSTALL_DATA) $(srcdir)/gsd-xrandr-clone-laptop.png $(stock_config_icon_dir)/gsd-xrandr-clone-laptop.png
+	$(INSTALL_DATA) $(srcdir)/gsd-xrandr-clone-monitors.png $(stock_config_icon_dir)/gsd-xrandr-clone-monitors.png
+	$(INSTALL_DATA) $(srcdir)/gsd-xrandr-custom.png $(stock_config_icon_dir)/gsd-xrandr-custom.png
+	$(INSTALL_DATA) $(srcdir)/gsd-xrandr-extended-ontop.png $(stock_config_icon_dir)/gsd-xrandr-extended-ontop.png
+	$(INSTALL_DATA) $(srcdir)/gsd-xrandr-extended-right.png $(stock_config_icon_dir)/gsd-xrandr-extended-right.png
+	$(INSTALL_DATA) $(srcdir)/gsd-xrandr-external.png $(stock_config_icon_dir)/gsd-xrandr-external.png
+	$(INSTALL_DATA) $(srcdir)/gsd-xrandr-laptop.png $(stock_config_icon_dir)/gsd-xrandr-laptop.png
 
 uninstall-local:
 	rm -f $(DESTDIR)$(icondir)/16x16/$(context)/gsd-xrandr.png
@@ -29,6 +47,14 @@ uninstall-local:
 	rm -f $(DESTDIR)$(icondir)/24x24/$(context)/gsd-xrandr.png
 	rm -f $(DESTDIR)$(icondir)/32x32/$(context)/gsd-xrandr.png
 	rm -f $(DESTDIR)$(icondir)/scalable/$(context)/gsd-xrandr.svg
+	rm -f $(stock_config_icon_dir)/gsd-xrandr-clone-laptop.png
+	rm -f $(stock_config_icon_dir)/gsd-xrandr-clone-monitors.png
+	rm -f $(stock_config_icon_dir)/gsd-xrandr-custom.png
+	rm -f $(stock_config_icon_dir)/gsd-xrandr-extended-ontop.png
+	rm -f $(stock_config_icon_dir)/gsd-xrandr-extended-right.png
+	rm -f $(stock_config_icon_dir)/gsd-xrandr-external.png
+	rm -f $(stock_config_icon_dir)/gsd-xrandr-laptop.png
+	rmdir $(stock_config_icon_dir)
 
 plugin_LTLIBRARIES = \
 	libxrandr.la
@@ -68,7 +94,7 @@ plugin_in_files =			\
 
 plugin_DATA = $(plugin_in_files:.gnome-settings-plugin.in=.gnome-settings-plugin)
 
-EXTRA_DIST = $(plugin_in_files) $(ICON_FILES) gsd-xrandr-manager.xml
+EXTRA_DIST = $(plugin_in_files) $(ICON_FILES) $(STOCK_CONFIG_ICON_FILES) gsd-xrandr-manager.xml
 CLEANFILES = $(plugin_DATA) $(BUILT_SOURCES)
 DISTCLEANFILES = $(plugin_DATA)
 
diff --git a/plugins/xrandr/gsd-xrandr-manager.c b/plugins/xrandr/gsd-xrandr-manager.c
index 4eebc64..b6738cc 100644
--- a/plugins/xrandr/gsd-xrandr-manager.c
+++ b/plugins/xrandr/gsd-xrandr-manager.c
@@ -91,8 +91,10 @@
 typedef enum {
         STOCK_CONFIG_CURRENT,
         STOCK_CONFIG_LAPTOP,
-        STOCK_CONFIG_CLONE,
-        STOCK_CONFIG_EXTENDED,
+        STOCK_CONFIG_CLONE_LAPTOP,
+        STOCK_CONFIG_CLONE_MONITORS,
+        STOCK_CONFIG_EXTENDED_RIGHT,
+        STOCK_CONFIG_EXTENDED_ONTOP,
         STOCK_CONFIG_EXTERNAL,
         STOCK_CONFIG_CUSTOM
 } StockConfigType;
@@ -858,6 +860,40 @@ print_configuration (GnomeRRConfig *config, const char *header)
                 print_output (config->outputs[i]);
 }
 
+static const char *
+get_icon_name_for_stock_config (StockConfigType type)
+{
+        switch (type) {
+        case STOCK_CONFIG_CURRENT:
+                return "gsd-xrandr-current";
+
+        case STOCK_CONFIG_LAPTOP:
+                return "gsd-xrandr-laptop";
+
+        case STOCK_CONFIG_CLONE_LAPTOP:
+                return "gsd-xrandr-clone-laptop";
+
+        case STOCK_CONFIG_CLONE_MONITORS:
+                return "gsd-xrandr-clone-monitors";
+
+        case STOCK_CONFIG_EXTENDED_RIGHT:
+                return "gsd-xrandr-extended-right";
+
+        case STOCK_CONFIG_EXTENDED_ONTOP:
+                return "gsd-xrandr-extended-ontop";
+
+        case STOCK_CONFIG_EXTERNAL:
+                return "gsd-xrandr-external";
+
+        case STOCK_CONFIG_CUSTOM:
+                return "gsd-xrandr-custom";
+
+        default:
+                g_assert_not_reached ();
+                return NULL;
+        }
+}
+
 static void
 stock_config_free (StockConfig *config)
 {
